#include <cstdio>
#include <cassert>
#include "amap.h"
#include "simap.h"

void test_basics(amap mapdo, void *map) {
	assert(NULL == mapdo(map, AMAP_GET, "asdf", NULL));
	int i = 42;
	int *iptr;
	assert(NULL != mapdo(map, AMAP_SET, "meaning", &i));
	assert(NULL != (iptr = (int *)mapdo(map, AMAP_GET, "meaning", NULL)));
	assert(*iptr == 42);
	assert(iptr == &i);
}

int main() {
	/* test simap */
	simap_instance si = simap_create();
	test_basics(simap, &si);

	return 0;
}
